require 'utils_drawer'
require 'safe_colorize'

require 'gpr/actions/status'

module Gpr
  module Commands
    class Status < Base
      using SafeColorize

      def initialize(thor)
        thor.class_eval do
          include UtilsDrawer
          include ::Gpr::Actions::Status

          desc 'status', 'Show the status of all registered repositories'
          def status
            repositories = repository_list
            table do
              row do
                column('REPOSITORY NAME'.style(:bold), 25)
                column('BRANCH STATUS'.style(:bold), 45)
                column('DIRECTORY STATUS'.style(:bold), 25)
              end
              repositories.each do |repository|
                status = git_status(repository)
                row do
                  column(repository.match(/.+\/(?<repository>.+\/.+)/)[:repository])
                  column(status[:branch])
                  column(status[:directory])
                end
              end
            end
          end
        end
      end
    end
  end
end
